'  option autorun on
  Option explicit
  option default FLOAT ' none
  option base 1
 
  SetPin 14,i2c1sda:  SetPin 15,i2c1scl ' : I2C1 open 100, 1000
  SetPin 1,uart0tx:SetPin 2,uart0rx ' : Open "com0:115200" As #1

  const sim=1 ' on pico, get around non-working commands
  const dspin=27
  const resetpin=22
  const requestpin=29: dim as integer requestpinVal = 1: setpin requestpin,dout
  const watchdogpin=31: dim as integer watchdogpinVal = 1: setpin watchdogpin,dout
' MM64 COM1: pins rx:59, tx:15 ' simulation
' MM64 COM2: pins rx:13, tx:11 ' Nextion DISPLAY
' MM64 COM3: pins rx:17, tx:16 ' zone temps \ setpoints
  
  const MaxLen=1024
  const hVarmax=26 ' max # html update variables
  
  ' Global variables
  const quote=chr$(34)
  CONST SSID$=quote+"Omnibus_N"+quote
  CONST SSIDPassword$=quote+"amber1977"+quote
'  const portno$="1234" 'set the port to be used for the webserver
  const portno$="9059" 'set the port to be used for the webserver
  '
  const starttext$="HTTP"
  const pnf$="<html><body>Page not Found</body></html>"
  const title$="<html><head><title>Some Title</title></head><body>"
  const ending$="</form></body></html>"
  const ON=1
  const off=0
  const TRUE=1
  const FALSE=0
  '   
  DIM as string sMonthNames(12) = ("January","February","March","April","May","June","July","August","September","October","November","December")
  dim integer iMonth, outsidetemp, pcbtemp, iMasterLoopCount
  dim float fLoopCountTimeout, fLoopCountLength
  dim integer iPos, jPos, flagVarChanged ' LB 170303
  dim as string sON length 10, sOFF length 10
  '
  ' Set up parameters
  '
  const waittime=1000 'wait time in readrequest before timeout
  ' html sVarVals indexes
  const h_frcmp=20,h_frrv=21,h_gasv=22,h_blwr=23,h_yardp=24,h_tankp=25,h_ahp=26,h_acool=27
  '
  '
  Dim arg$(2,hVarmax) length 20
  DIM INTEGER inbuf(Maxlen\4) 'global input buffer
  dim string CRLF=chr$(13)+chr$(10) length 2
  
  dim integer IPDno  'global IPD numbers used to ensure transmit is on correct IPD
  dim integer nparams, connected=0, ds18B20timeout
  dim as string pageX$ 'variables used by main loop only
  dim as string lastPageType$ length 1 ' I=INDEX,S=SIM,
  dim as integer firstSend=1, tstatSetpoint=72, roomTemp, simRoomTemp
  dim as integer iMode, iHeat, iCool, iOAT ' outside air temperature; controls auto mode setting
  DIM obuff$="" 'used to buffer writes to the internet to optimise speed
  dim as string sRelaySettings length 16
  dim as string sLastRelaySettings length 16 = "0000000000000000"
  dim as string sVarSave ' comma-separated values saved with var save
  dim as string sFrom length 12, sTo length 12
  DIM AS string sVarVals(83) length 30
  dim AS string sDay, sDayOfWeek(7) length 10 = ("Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday")
  dim as integer iDayOfWeek, iToday, iMaxsVarVal=58
  dim as string a$,b$,c$,s$
  'Chartreuse, red
  
'' LB server definitions & initializations
  CONST longStringMaxLen=6120
  DIM as string htmlRequest$
  dim as INTEGER htmlBuffer(longStringMaxLen/4) ' LB 170310
  DIM AS STRING htmlLine, templateLine, sHTMLVarNo length 2
  DIM AS INTEGER i,j,k,l,m,n
  CONST maxVars=83
  DIM AS INTEGER nVarNdx(maxVars), nVarNos(maxVars)

  DIM AS FLOAT OATactual=31 : DIM AS INTEGER OATactualNdx=07
  DIM AS FLOAT Hall=71 : DIM AS INTEGER HallNdx=08
  DIM AS FLOAT Mode=0 : DIM AS INTEGER ModeNdx=09
  DIM AS FLOAT Zone1=70.1 : DIM AS INTEGER Zone1Ndx=12
  DIM AS FLOAT Zone1Set=72 : DIM AS INTEGER Zone1SetNdx=13
  DIM AS FLOAT Zone2=70.3 : DIM AS INTEGER Zone2Ndx=14
  DIM AS FLOAT Zone2Set=72 : DIM AS INTEGER Zone2SetNdx=15
  DIM AS FLOAT Zone3=74 : DIM AS INTEGER Zone3Ndx=16
  DIM AS FLOAT Zone3Set=72 : DIM AS INTEGER Zone3SetNdx=17
  DIM AS FLOAT Zone4=70 : DIM AS INTEGER Zone4Ndx=18
  DIM AS FLOAT Zone4Set=72 : DIM AS INTEGER Zone4SetNdx=19
  DIM AS FLOAT Zone5=70 : DIM AS INTEGER Zone5Ndx=20
  DIM AS FLOAT Zone5Set=72 : DIM AS INTEGER Zone5SetNdx=21
  DIM AS FLOAT Zone6=73.2 : DIM AS INTEGER Zone6Ndx=22
  DIM AS FLOAT Zone6Set=72 : DIM AS INTEGER Zone6SetNdx=23
  DIM AS FLOAT HallHeat2Set=72 : DIM AS INTEGER HallHeat2SetNdx=24
  DIM AS FLOAT HallHeat3Set=71 : DIM AS INTEGER HallHeat3SetNdx=25
  DIM AS FLOAT HallCoolSet=75 : DIM AS INTEGER HallCoolSetNdx=26
  DIM AS FLOAT OATHeat1Mx=60 : DIM AS INTEGER OATHeat1MxNdx=27
  DIM AS FLOAT OATHeat2Mx=40 : DIM AS INTEGER OATHeat2MxNdx=28
  DIM AS FLOAT OATHeat3Mx=25 : DIM AS INTEGER OATHeat3MxNdx=29
  DIM AS FLOAT OATCoolMn=75 : DIM AS INTEGER OATCoolMnNdx=30
  DIM AS FLOAT TimeFrnHoldOffSet=180 : DIM AS INTEGER TimeFrnHoldOffSetNdx=31
  DIM AS FLOAT DataDmpElapSet=3 : DIM AS INTEGER DataDmpElapSetNdx=32
  DIM AS FLOAT YardFeed=33 : DIM AS INTEGER YardFeedNdx=33
  DIM AS FLOAT YardFeedMx=105 : DIM AS INTEGER YardFeedMxNdx=34
  DIM AS FLOAT YardFeedMn=32.4 : DIM AS INTEGER YardFeedMnNdx=35
  DIM AS FLOAT YardReturn=38 : DIM AS INTEGER YardReturnNdx=36
  DIM AS FLOAT YardReturnMx=105 : DIM AS INTEGER YardReturnMxNdx=37
  DIM AS FLOAT YardReturnMn=32.4 : DIM AS INTEGER YardReturnMnNdx=38
  DIM AS FLOAT FrnLo=25 : DIM AS INTEGER FrnLoNdx=39
  DIM AS FLOAT FrnLoMx=85 : DIM AS INTEGER FrnLoMxNdx=40
  DIM AS FLOAT FrnLoMn=20 : DIM AS INTEGER FrnLoMnNdx=41
  DIM AS FLOAT FrnHi=120 : DIM AS INTEGER FrnHiNdx=42
  DIM AS FLOAT FrnHiMx=145 : DIM AS INTEGER FrnHiMxNdx=43
  DIM AS FLOAT FrnHiMn=35 : DIM AS INTEGER FrnHiMnNdx=44
  DIM AS FLOAT TankFeed=120 : DIM AS INTEGER TankFeedNdx=45
  DIM AS FLOAT TankFeedMx=130 : DIM AS INTEGER TankFeedMxNdx=46
  DIM AS FLOAT TankFeedMn=33 : DIM AS INTEGER TankFeedMnNdx=47
  DIM AS FLOAT TankReturn=105 : DIM AS INTEGER TankReturnNdx=48
  DIM AS FLOAT TankReturnMx=130 : DIM AS INTEGER TankReturnMxNdx=49
  DIM AS FLOAT TankReturnMn=33 : DIM AS INTEGER TankReturnMnNdx=50
''
  Init:
  logToFile("!","Startup")
'  I2C open 100, 1000
'    rtc SETREG 0-seconds,1-min,2=hr;,3-dow,4=d,5=mo,6=yr
'    rtc SETREG 2,10 ' set hour; daylight savings time, march 12, 2017
'    rtc SETREG 2,21 ' set hour
'    rtc SETREG 1,7 ' set minute
'    rtc SETREG 3,5 ' set day of week: monday = 0
' RTC SETTIME year, month, day, hour, minute, second
'  RTC SETTIME 2017, 3, 12, 21, 11, 30
  pause 1000
  rtc_gettime
  print "DATE: ";date$
  print "TIME: ";TIMe$
'   for i = 1 to 7 : print sDayOfWeek(i)+" " : next i
  setupSim
  lastPageType$ = "S" ' set up initial simulation values
  newday
  print sVarVals(1)
  print sVarVals(2)
  
'  for i = 1 to 12 : print sMonthNames(i)+" " : next i
'  setpin dspin,dout ' temperature reading
  if not sim then print "Temp: "+str$(TEMPR(dspin,3)) 'measure temp to 0.0625 degree accuracy
  setpin resetpin,dout
  pin(resetpin)=0 'put the ESP8266 into reset
'  bme280_init
'  ds18B20 start dspin,3 'measure temp to 0.0625 degree accuracy
  if not sim then tempr start dspin,3 'measure temp to 0.0625 degree accuracy
  pause 1000
'  outsidetemp=cint(ds18B20(dspin)*10)
  if not sim then outsidetemp=cint(tempr(dspin)*10)
  if not sim then tempr start dspin,3 'start a temperature conversion
  var restore 'recover comma separated variables in sVarSave
  if sVarSave <> "" then varRestore
  if iMode < 0 or iMode > 3 then iMode = 0
'  setpin 53,dout:setpin 42,dout
'  pin(53)=1:pin(42)=1:pause 1000:pin(53)=0:pin(42)=0:pause 1000 ' test LEDs on these pins
'  pin(53)=1:pin(42)=1:pause 1000:pin(53)=0:pin(42)=0
  pause 5000 'wait for ESP8266 to stabilise afer power on
  print "Opening COM for ESP-01"
  open "com0:115200,4096" as #9
  pin(resetpin)=1 'release the ESP8266 from reset
  timer=0
  do while TIMER<20000
    IF loc(#9)<>0 then 
      longstring append inbuf(),input$(min(255,loc(#9)),#9)
    endif
    if LLen(inbuf())>15 then
      if LInstr(inbuf(),"WIFI GOT IP") then
        connected=1 'set that we have got a connection
        exit DO
      endif
    endif
  loop
  close #9 'clear the buffer
SetPin 1,uart0tx:SetPin 2,uart0rx ' ??? remove with matherp fixes
  print "Reopening COM for ESP-01 as #9 for html simulation "
  open "com0:115200,4096" as #9
  print #9,"+++"; 'ensure the ESP is in command mode
  pause 500
  IF NOT Command("AT",500) THEN END  'If not responding to AT we have a problem
  if not connected then
    IF NOT Command("AT+RST",10000,"WIFI GOT IP") THEN 'software reset and check for valid connection
      PRINT "Set up WIFI on SSID: ",SSID$
      IF NOT Command("AT+CWMODE_DEF=1",5000) THEN END 'set device mode (1=client, 2=AP, 3=both)
      IF NOT Command("AT+CWLAP",30000) THEN END 'scan for WiFi hotspots
      printlong(inbuf()) 'output the list of valid networks
      IF NOT Command("AT+CWJAP_DEF="+SSID$+","+SSIDPassword$,20000,"WIFI GOT IP") THEN END 'connect
      IF NOT Command("AT+CIFSR",5000) THEN END 'check IP address
    ENDIF
  else
  endif
  IF NOT Command("AT+CIPMUX=1",5000) THEN END
  IF NOT Command("AT+CIPSERVER=1,"+portno$,5000) THEN END
  IF NOT Command("AT+CIPSTA="+quote+"192.168.2.124"+quote,5000) then : endif
  pause 1000
  print "Getting IP: ";
  IF Command("AT+CIFSR",5000) THEN  'check IP address
'    pause 1000
    iPos=LInstr(inbuf(),quote,1) ' opening quote
    if iPos > 0 then
      jPos=LInstr(inbuf(),quote,iPos+1) ' closing quote
      if jPos > 0 then
        print LGetStr$(inbuf(),iPos+1,jPos-iPos-1)
      endif
    endif
    print LGetStr$(inbuf(),1,140)
  endif
  Print ""
  Print "Connected"
'  ds18B20 start dspin,3 'start a new temperature conversion
'  pause 1000
  if not sim then outsidetemp=cint(tempr(dspin)*10) 'read the temperature from the last conversion
  pcbtemp=outsidetemp*9/5+32
  ds18B20timeout = timer ' immediate read
  print "Temperature: "+outtemp$(outsidetemp)
  iMasterLoopCount = 0
  fLoopCountLength = 600 ' 10 minutes -- 120 ' 2 minutes
  fLoopCountTimeout = TIMER + (1000*fLoopCountLength)
'  iMode = 0
  iMode=2 ' LB 210612 2=heat
  lastPageType$ = "S" ' LB 210612 ???
  readHTMLTemplate
  print "Ready for user input"
  
main:
  DO
    '??? watchdog 10000 ' if not executed in 10 seconds, restart
    iMasterLoopCount = iMasterLoopCount +1
    pin(watchdogpin) = watchdogpinVal
    if watchdogpinVal = 1 then : watchdogpinVal = 0 : else : watchdogpinVal = 1 : endif
    if ds18B20timeout < timer then
      if not sim then PCBtemp=cint(tempr(dspin)) ' *10) 'read the temperature from the last conversion
      sVarVals(32)=str$(pcbTemp*9/5+32)
      if not sim then tempr start dspin,3 'start a new temperature conversion
      ds18B20timeout = timer+1000 ' wait 1 second before reading
    endif
'    outsidetemp=cint(tempr(dspin)*10) 
         'read the temperature from the last conversion
'    tempr start dspin ' ,3 'start a new temperature conversion
    if ReadRequest(waittime) then 
        'process HTML request (watchdog: requestpin)
      htmlRequest$ = parsehtmldata$(nparams) ' builds arg$(1/2,nparams) name/value pairs
      print "nparams: ";nparams;": |";htmlRequest$;"|"
'      pageX$=ucase$(parsehtmldata$(nparams)) 
           'parse the html request and get the page requested
      pageX$=ucase$(htmlRequest$) 
            'parse the html request and get the page requested
'      pageX$=htmlRequest$ 'parse the html request and get the page requested
      if pageX$<>"" then 'real request so do something
        firstSend = 1 ' LB print first buffer of html code sent
        if pageX$= "INDEX" then
          setupIndex
          drawpage
        elseif pageX$="LIST" then ' list logfile
          sFrom="":sTo=""
          if arg$(1,1) = "A" then sFrom = arg$(2,1)
          if arg$(1,2) = "B" then sTo = arg$(2,2)
          logList(sFrom,sTo)
        elseif pageX$="SIM" then ' simulation page
          setupSim
          setRelays
          drawpage
        elseif pageX$="G" then ' geothermal simulation variable update
          if nparams<>0 then 'we have parameters to process
            print "nparams: "+str$(nparams)
            flagVarChanged = FALSE
            for i = 1 to nparams
              if arg$(1,i) <> "" then
                print arg$(1,i)+"="+arg$(2,i)+" ";
'                if i mod 10 = 0 then : print "" : endif
                if arg$(1,i) = "Y" then ' mode -- sVarVals(5.6.7.8) -- one only is "checked"
                  j = val(arg$(2,i)) - val("0") + 5 ' index into sVarVals
                  iMode = j - 5
                  print "iMode = "+str$(iMode)
                  if sVarVals(j) = "" then ' wasn't checked; now should be
                    sVarVals(5) = "": sVarVals(6) = "": sVarVals(7) = "": sVarVals(8) = ""
                    sVarVals(j) = "checked"
                    logToFile("Y", str$(iMode))
                    var save iMode
                  endif
                else ' all other named html elements ("A"-"X")
                  IF arg$(1,i) <= "J" THEN
                    j = asc(arg$(1,i))-asc("A")+50 ' A/71 name value pair is sVarVals(40), value 71
                  ELSE ' K-R
                    j = asc(arg$(1,i))-asc("K")+40 ' A/71 name value pair is sVarVals(40), value 71
                  ENDIF
                  print "i,j: "+str$(i)+" "+str$(j)+" |"+sVarVals(j)+"|"
                  if arg$(2,i) <> sVarVals(j) then
                    print crlf+arg$(1,i)+": "+arg$(2,i)+" updates "+sVarVals(j)
                    sVarVals(j) = arg$(2,i)
                    logToFile(arg$(1,i), sVarVals(j))
                    flagVarChanged = TRUE
                  endif
                endif
              endif
            next i
            print ""
            if flagVarChanged then varSave ' save the temperature readings
            sVarVals(30) = sVarVals(40)
            iOAT = val(sVarVals(30))
          endif
          setRelays
          drawpage
        elseif pageX$="D" then
          if nparams<>0 then 'we have parameters to process
            if arg$(1,1)="S" and arg$(2,1) = password$ then
              if arg$(1,2)="C" and arg$(2,2)="R" then 'reset the max min to current
'                var save setpoint, maxtemp, mintemp, maxoutsidetemp, minoutsidetemp, minhumidity,maxhumidity, minpressure, maxpressure
              endif
              if arg$(1,2)="R" then 'change the setpoint and update the heater if applicable
                setpoint=asc(arg$(2,2))
'                var save setpoint, maxtemp, mintemp, maxoutsidetemp, minoutsidetemp, minhumidity,maxhumidity, minpressure, maxpressure
'                updateheater
              endif
            endif
          endif
          drawpage
        elseif pageX$="A" then
          sendText "HTTP/1.1 200 OK"+crlf+"Content-type: text/html"+crlf+"Connection: close"+crlf+crlf
          firstSend = 1
          sendText title$+"Bingo!</body></html>"+crlf+crlf
        else
          sendText "HTTP/1.1 200 OK"+crlf+"Content-type: text/html"+crlf+"Connection: close"+crlf+crlf
          SendText pnf$+crlf+crlf'invalid page
        endif
        EndSend 'clear the write buffer and terminate the write
      endif
    endif
    if fLoopCountTimeout <= TIMER then
      i = iMasterLoopCount / fLoopCountLength
      print iMasterLoopCount; " Master Loop Passes this period;";i;"/second ";mid$(time$,1,5)
'      fLoopCountTimeout = TIMER + (86400 * 1000) ' 24 hours later
      fLoopCountTimeout = TIMER + (1000*fLoopCountLength)
      iMasterLoopCount = 0
    endif
  LOOP
end
  
sub drawpage
?"Entering drawpage"
  if mid$(DATE$,1,1)="0" then : sDay = mid$(date$,2,1) : else : sDay = mid$(date$,1,2) : endif
  if iToday <> val(sDay) then
    newday
  endif
  sendText "HTTP/1.1 200 OK"+crlf+"Content-type: text/html"+crlf+"Connection: close"+crlf+crlf
  putHTML
if 1 = 0 then ' never do
  if lastPageType$ = "I" then
    open "geotmplt.txt" for input as #10
  else
    open "geotmpl2.txt" for input as #10 ' simulation
    print "opening geotmpl2.txt as #10 for simulation"
  endif
  l = 0
  do while not eof(#10)
    line input #10,templateLine
    l = l + 1
'    print str$(l)+": "+templateLine
    j = instr(templateLine,"~")
    i=1
    htmlLine = ""
    do while j > 0
      sHTMLVarNo = mid$(templateLine,j+1,2)
'      print "'";B;"'";j;" ";templateLine
      htmlLine = htmlLine + mid$(templateLine,i,j-i)
      k = VAL(sHTMLVarNo)
      if k > 0 and k <= maxVars then
        htmlLine = htmlLine+sVarVals(k)
      else
        PRINT "Invalid varNo: ";templateLine
      endif
      i = j + 3
      j = instr(i,templateLine,"~")
    loop
    htmlLine = htmlLine + mid$(templateLine,i)
    sendText htmlLine+crlf
'    print "-> "+htmlLine
  loop
  close #10
endif ' if 1 = 0 then
  
  sendText crlf+crlf
  print "html page output complete "+mid$(TIMe$,1,5)
end sub
'
Function parsehtmldata$(paramcount as integer)
  local a$,b$
  local INTEGER buf(Maxlen\4)
  local integer inpos,startparam,processargs
  paramcount=1 ' LB as array index, values starting from 1 instead of from 0
  inpos=LInstr(inbuf(),"GET /",1)
  if inpos=0 then
    parsehtmldata$=""
  else
'    LONGSTRING MID buf(),inbuf(),inpos+5
    LONGSTRING MID buf(),inbuf(),inpos+5, 255
    inpos=LInstr(buf(),starttext$,1)
    if inpos > 0 then 
      logToFile("!",LGetStr$(buf(), 1, inpos-1)) ' log input request
    endif
    print LGetStr$(buf(), 1, 100)
    If inpos>2 Then 'page request found
      inpos=inpos-2
      a$=LGetStr$(buf(),1,inPos)
      inpos=Instr(a$,"?")
      If inpos<>0 Then 'parameters found
        processargs=1
        parsehtmldata$=Left$(a$,inpos-1)
        a$=Mid$(a$,inpos+1)
        Do
          arg$(1,paramcount)=""
          arg$(2,paramcount)=""
          inpos=Instr(a$,"=")
          startparam=1
          arg$(1,paramcount)=Mid$(a$,startparam,inpos-startparam)
          startparam=inpos+1
          inpos=Instr(a$,"&")
          If inpos<>0 Then
            arg$(2,paramcount)=Mid$(a$,startparam,inpos-startparam)
            a$=Mid$(a$,inpos+1)
            paramcount=paramcount+1
          Else
            arg$(2,paramcount)=Mid$(a$,startparam)
            paramcount=paramcount+1
            processargs=0
          EndIf
        Loop while processargs
      Else
        parsehtmldata$=a$
      EndIf
    Else ' no page requested
      parsehtmldata$="INDEX"
    EndIf
  endif
End Function
  
'  const h_frcmp=20,h_frrv=21,h_gasv=22,h_blwr=23,h_yardp=24,h_tankp=25,h_ahp=26,h_acool=27
  
sub setRelays
  sVarVals(30)=sVarVals(40) ' OAT
  sVarVals(31)=sVarVals(41) ' Hallway
  iHeat = 0 : iCool = 0
  if iMode = 0 then
    sON = "red" : sOFF = "red" ' everything off
    for j = 20 to 27 : sVarVals(j) = sOFF : next j
  else
    sON = "chartreuse" : sOFF = "red" ' everything off
    if iMode = 1 then : iHeat = 1 : freonCycleHeating : endif
    if iMode = 2 then : iCool = 1 : freonCycleCooling : endif
    if iMode = 3 then
      if iOAT > 72 then : iCool = 1 : freonCycleCooling : endif
      if iOAT <= 72 then : iHeat = 1 :  freonCycleHeating : endif
    endif
    if iCool = 1 then ' check for supplemental
      if iOAT > 93 then
        sVarVals(h_ahp) = sON
        sVarVals(h_acool) = sON
      elseif iOAT > 86 then
        sVarVals(h_ahp) = sON
        sVarVals(h_acool) = sOFF
      else
        sVarVals(h_ahp) = sOFF
        sVarVals(h_acool) = sOFF
      endif
    endif
    if iHeat = 1 then ' check for supplemental
      if iOAT < 25 then
        sVarVals(h_gasv) = sON
        sVarVals(h_blwr) = sON
      else
        sVarVals(h_gasv) = sOFF
        sVarVals(h_blwr) = sOFF
      endif
    endif
  endif
  sRelaySettings = "" ' 16 bytes "0" or "1" pumps on/off
'    freon cycle pumps 20-27
  for j = 20 to 27 ' freon cycle pumps off (red) or on (chartreuse)
    if sVarVals(j) = "red" then 
      sRelaySettings = sRelaySettings + "0"
    else
      sRelaySettings = sRelaySettings + "1"
    endif
  next j
'    distrib pumps 9-14
  for j = 9 to 14 ' distrib pumps off (red) or on (chartreuse)
    i = j+33
    simRoomTemp = val(sVarVals(i))
    if simRoomTemp <= tstatSetpoint then
      if iHeat = 1 then
        sVarVals(j) = sON
      elseif iCool = 1 then
        sVarVals(j) = sOFF
      else
        sVarVals(j) = sOFF
      endif
    else
      if iHeat = 1 then
        sVarVals(j) = sOFF
      elseif iCool = 1 then
        sVarVals(j) = sON
      else
        sVarVals(j) = sOFF
      endif
    endif
    print str$(j)+" "+str$(i)+" "+str$(iHeat)+" "+str$(iCool)+" "+str$(iOAT)+" "+str$(simRoomTemp)+" "+sVarVals(j)
    if sVarVals(j) = "red" then 
      sRelaySettings = sRelaySettings + "0"
    else
      sRelaySettings = sRelaySettings + "1"
    endif
  next j
  sRelaySettings = sRelaySettings + "00" ' no pumps here
  logToFile("Z", sRelaySettings) ' "Z" is relays
  
end sub
'
function outtemp$(t as integer)
  local integer tenths=t mod 10
  local integer units= t\10
  outtemp$=str$(units,3)+"."+chr$(tenths+48)
end function
  '
sub printLONG(ret!()) 'used for debugging
  local integer i%=Slen(ret!()),j%=1
  DO
    if i%>255 then
      print SGetStr(ret!(),j%,255);
      i%=i%-255
      j%=j%+255
    else
      PRINT SGetStr(ret!(),j%,i%)
      i%=0
    endif
  loop while i%>0
  
end sub
  
sub EndSend
  local b$
  b$="AT+CIPSEND="+CHR$(IPDno+48)+","+STR$(len(obuff$)) 'send anything still in the buffer
  IF NOT Command(b$,500,">") THEN
    if LInstr(inbuf(),"link is not valid") then exit sub
  endif
  IF NOT Command(obuff$,500) THEN END
  pause 200 ' LB 170303
  IF NOT Command("AT+CIPCLOSE="+CHR$(IPDno+48),500) THEN
    if LInstr(inbuf(),"UNLINK") then
      obuff$=""
      exit sub
    else
end
    endif
  endif
  obuff$=""
end sub
  
sub SendText(a$)
  local b$
  if firstSend = 1 then
    firstSend = 0
    print a$
  endif
  if len(a$)+len(obuff$)< 240 then 'add the new string to the output buffer
    obuff$=obuff$+a$
  else 'too big to fit so send the current output buffer
    b$="AT+CIPSEND="+CHR$(IPDno+48)+","+STR$(len(obuff$))
    IF NOT Command(b$,1000,">") THEN ' LB was 500
      if LInstr(inbuf(),"link is not valid") then exit sub
    endif
    IF NOT Command(obuff$,1000) THEN END ' LB was 500
    obuff$=a$
  endif
end sub
'
FUNCTION ReadRequest(timeout%) as integer
      pin(requestpin) = requestpinVal
      if requestpinVal = 1 then : requestpinVal = 0 : else : requestpinVal = 1 : endif
  ReadRequest=0
  Longstring Clear inbuf()
  if loc(#9)<>0 then
    do while loc(#9)<>0
      pause 100 ' allow characters to arrive
      longstring append inbuf(),input$(min(255,loc(#9)),#9)
      pause 10 ' allow characters to arrive
    loop
    if (NOT LInstr(inbuf(),"favicon",0)) and (NOT LInstr(inbuf(),"CONNECT FAIL",1)) then
      ReadRequest=1 'junk the favicon requests and disconnects
    endif
    IF LInstr(inbuf(),"IPD,0",1) then IPDno=0
    IF LInstr(inbuf(),"IPD,1",1) then IPDno=1
  endif
end function
'
'
FUNCTION Command(AT$, timeout%, other$) as integer 'send a command and wait for the answer
  local as integer endtime%
  local i%=0,j%
  Local a$
  Command=0
  Longstring Clear inbuf()
  print #9,AT$+crlf;
' LB  TIMER=0
  endtime% = timer+timeout%
  i%=0
  do
    pause 100
' LB    if TIMER>timeout% then
    if TIMER>endtime% then
      Print "Timeout : "+AT$
      EXIT DO
    endif?
    j%=LOC(#9)
    if j%>0 then
      i%=i%+min(255,j%)
      s$=input$(min(255,j%),#9)
      LONGSTRING append inbuf(),s$
      if Llen(inbuf())>4 and other$="" then
        if LInstr(inbuf(),"OK",1) then
          Command=1
          exit DO
        endif
      endif
      if Llen(inbuf())>7 then
        if LInstr(inbuf(),"ERROR",1) then
          Print "ERROR : "+AT$+crlf+"    :"+LGetStr$(inbuf(),1,140)
          exit DO
        endif
      endif
      if Llen(inbuf())>len(other$)+2 then
        if LInstr(inbuf(),other$,1) then
          Command=1
          exit DO
        endif
      endif
    endif
  loop
end function
'
'******************************************************************************
'
Sub newday
'  rtc GETREG 3,iDayOfWeek
'  iDayOfWeek = iDayOfWeek mod 7 + 1
  iDayOfWeek = (iDayOfWeek-1) mod 7 + 1
  print "DOW: "+str$(iDayOfWeek)+" -- ",sDayOfWeek(iDayOfWeek)
  iMonth=val(mid$(date$,4,2))
  if mid$(DATE$,1,1)="0" then
    sDay = mid$(date$,2,1)
  else
    sDay = mid$(date$,1,2)
  endif
  iToday = val(sDay)
  if lastPageType$ = "I" then
    sVarVals(51)=sDayOfWeek(iDayOfWeek)+", "+sMonthNames(iMonth)+" "+sDay+", "+mid$(DATE$,7)
    sVarVals(52)=mid$(time$,1,5) ' "8:52pm"
  else
    sVarVals(1)=sDayOfWeek(iDayOfWeek)+", "+sMonthNames(iMonth)+" "+sDay+", "+mid$(DATE$,7)
    sVarVals(2)=mid$(time$,1,5) ' "8:52pm"
    print sVarVals(1)+" "+sVarVals(2)
  endif
end sub
' 
function q(x as integer) as integer  'returns 2 raised to the power
  q=(1<<x)
End CFunction
  
sub setupIndex
?"Entering setupIndex; lastPageType$="+lastPageType$
  If lastPageType$ <> "I" then
 'if 1=0 then ' ??? LB210612
'    sVarVals(51)="Saturday 04/03/17"
'    sVarVals(52)="8:52pm"
    sVarVals(3)="chartreuse" ' lb 210612
    sVarVals(4)="red"  ' lb 210612
    sVarVals(5)="checked" ' lb 210612
    sVarVals(6)=""
    sVarVals(7)="31"
    sVarVals(8)="71"
'    sVarVals(9)="0"
'    sVarVals(10)="0"
'    sVarVals(11)="0"
'    sVarVals(12)="70.1"
'    sVarVals(13)="72"
'    sVarVals(14)="70.3"
    sVarVals(15)="72"
    sVarVals(16)="74"
    sVarVals(17)="72"
    sVarVals(18)="70"
    sVarVals(19)="72"
    sVarVals(20)="70"
    sVarVals(21)="72"
    sVarVals(22)="73.2"
    sVarVals(23)="72"
    sVarVals(24)="72"
    sVarVals(25)="71"
    sVarVals(26)="75"
    sVarVals(27)="60"
    sVarVals(28)="40"
    sVarVals(29)="25"
    sVarVals(30)="25"
    sVarVals(31)="72"
    sVarVals(32)="3"
    sVarVals(33)="33"
    sVarVals(34)="105"
    sVarVals(35)="32.4"
    sVarVals(36)="38"
    sVarVals(37)="105"
    sVarVals(38)="32.4"
    sVarVals(39)="25"
    sVarVals(40)="85"
    sVarVals(41)="20"
    sVarVals(42)="120"
    sVarVals(43)="145"
    sVarVals(44)="35"
    sVarVals(45)="120"
    sVarVals(46)="130"
    sVarVals(47)="33"
    sVarVals(48)="105"
    sVarVals(49)="130"
    sVarVals(50)="38"
    sVarVals(51)="33"
    sVarVals(52)="105"
    sVarVals(80)=""
    sVarVals(81)=""
    sVarVals(82)=" checked"
    sVarVals(83)=""
    lastPageType$ = "I"
    iOAT = val(sVarVals(12))
    freonCycleHeating ' ??? LB210612
    
  endif
end sub
  
sub setupSim  
lastPageType$="S" ' LB 210612
?"Entering setupSim; lastPageType$="+lastPageType$ ' LB 210612
setupIndex
'  If lastPageType$ <> "S" then
if 1=1 then
    sVarVals(1)="Saturday 04/03/17"
    sVarVals(2)="8:52pm"
    sVarVals(3)="chartreuse"
    sVarVals(4)="red"
    sVarVals(5)="checked"         ' OFF, HEAT, COOL, AUTO ("checked")
    sVarVals(6)=""
    sVarVals(7)=""
    sVarVals(8)=""
' const h_W_OFF=9,h_TV=10,h_DINR=11,h_LIVR=12,h_S_BR=13,h_N_BR=14
    sVarVals(9)="chartreuse" ' distribution pumps
    sVarVals(10)="red"
    sVarVals(11)="red"
    sVarVals(12)="chartreuse"
    sVarVals(13)="chartreuse"
    sVarVals(14)="red"
    sVarVals(15)=""
    sVarVals(16)=""
    sVarVals(17)=""
    sVarVals(18)=""
    sVarVals(19)=""
    
    freonCycleHeating
    sVarVals(28)=""
    sVarVals(29)=""
    
    sVarVals(30)="35" ' OAT
    sVarVals(31)="72" ' hall
    sVarVals(32)=""
    sVarVals(33)=""
    sVarVals(34)=""
    sVarVals(35)=""
    sVarVals(36)=""
    sVarVals(37)=""
    sVarVals(38)=""
    sVarVals(39)=""
    
    sVarVals(40)="35" ' K OAT
    sVarVals(41)="71" ' L Hall
    sVarVals(42)="73" ' M W_OFF
    sVarVals(43)="70" ' N TV
    sVarVals(44)="72" ' O DINR
    sVarVals(45)="72" ' P LIVR
    sVarVals(46)="71" ' Q S_BR
    sVarVals(47)="73" ' R N_BR
    sVarVals(48)=""
    sVarVals(49)=""
    
'  dim as integer iSimVals(24), iSimVal=0, iSimVarNo=0 
' (75,60,45,35,35,120,35,110,33,120,33,120,40)
    
    sVarVals(50)="29.5"  ' "75" ' A Yard in
    sVarVals(51)="34.3"  ' "60" ' B Yard out
    sVarVals(52)="105.0" ' "45" ' C Tank in
    sVarVals(53)="95.8"  ' "35" ' D Tank out
    sVarVals(54)="100.1" ' "34" ' E Tank center
    sVarVals(55)="34.6"  ' "120" ' F compressor in
    sVarVals(56)="120.3" ' "35" ' G compressor out
    sVarVals(57)="110.9" ' "110" ' H txv in
    sVarVals(58)="27.6"  ' "120" ' I txv out
    lastPageType$ = "S"
    iOAT = val(sVarVals(30))
  endif
  sVarVals(2)=mid$(time$,1,5) ' "8:52pm"
  sVarVals(32)=str$(pcbTemp*9/5+32)
end sub
  
'  const h_frcmp=20,h_frrv=21,h_gasv=22,h_blwr=23,h_yardp=24,h_tankp=25,h_ahp=26,h_acool=27
sub freonCycleHeating
  sVarVals(20)="chartreuse" ' freon cycle pumps
  sVarVals(21)="red"
  sVarVals(22)="red"
  sVarVals(23)="red"
  sVarVals(24)="chartreuse"
  sVarVals(25)="chartreuse"
  sVarVals(26)="red"
  sVarVals(27)="red"
  sVarVals(28)="red"
end sub
  
sub freonCycleCooling
  sVarVals(20)="red" ' freon cycle pumps
  sVarVals(21)="chartreuse"
  sVarVals(22)="red"
  sVarVals(23)="red"
  sVarVals(24)="chartreuse"
  sVarVals(25)="chartreuse"
  sVarVals(26)="red"
  sVarVals(27)="red"
  sVarVals(28)="red"
end sub

sub logToFile(id as string, a as string)
  local timeStamp as string
  timeStamp = mid$(DATE$,9)+mid$(DATE$,4,2)+mid$(DATE$,1,2)
  timeStamp = timeStamp+mid$(timE$,1,2)+mid$(timE$,4,2)+mid$(timE$,7,2)
  open "log.txt" for append as #8 ' log
  print #8,timeStamp+" "+id+" "+a
  close #8
end sub

sub varSave
  sVarSave = sVarVals(40)
  for i = 41 to 58 ' simulation values
    sVarSave = sVarSave + "," + sVarVals(i)
  next i
  var save sVarSave
  print sVarSave
end sub

sub varRestore
  i = 1
  k = 40
  j = instr(sVarSave,",")
  do while j > 0
    sVarVals(k) = mid$(sVarSave,i,j-1)
    k = k + 1
    i = j + 1
    j = instr(i,sVarSave,",")
  loop
  sVarVals(k) = mid$(sVarSave,i)
  print "sVarVals(40)-("+str$(k)+") restored"
'  print sVarSave
end sub

sub logList(ssFrom as string, ssTo as string)
  local as string A
  if ssTo = "" then ssTo = "9" ' list to end of file
  open "log.txt" for input as #8 ' log
  do while not eof(#8)
    line input #8,A
    if mid$(A,1,len(ssFrom)) => ssFrom and A < ssTo then
'[    print A
      SendText A+crlf
    endif
  loop
  close #8
end sub

sub readHTMLTemplate
?"Entering readHTMLTemplate"
  open "geotmpl2.txt" for input as #10 ' simulation
  print "opening geotmpl2.txt as #10 for simulation html template"
  Longstring Clear htmlBuffer()
  do while not eof(#10)
    line input #10,templateLine
'    htmlBuffer = htmlBuffer + templateLine
    LONGSTRING APPEND htmlBuffer(), templateLine
  loop
  close #10
'  j = instr(htmlBuffer,"~")
  j = LInstr(htmlBuffer(),"~")
  i = 1
  n = 1
'  DIM AS INTEGER nVarNdx(maxVars), nVarNos(maxVars)
  do while j > 0
'      sHTMLVarNo = mid$(htmlBuffer,j+1,2)
      sHTMLVarNo = lGetStr$(htmlBuffer(),j+1,2)
      k = VAL(sHTMLVarNo)
      if k > 0 and k <= maxVars then
        nVarNdx(n) = j ' character after end of string
        nVarNos(n) = k
'  print "nijk "+str$(n)+" "+str$(i)+" "+str$(j)+" "+str$(k)
        n = n + 1
      else
        PRINT "Invalid varNo: ";htmlBuffer
      endif
      i = j + 3
'      j = instr(i,htmlBuffer,"~")
      j = LInstr(htmlBuffer(),"~",i)
  loop
  nVarNdx(n) = 99999 ' invalid length
  print str$(n)+" variables found in html template"
'  printHTML
end sub

sub putHTML
?"Entering putHTML"
  n = 1
  i = 1
  j = nVarNdx(n) 
  do while j <> 99999
    k = j - i
    do while k > 250
      sendText LGetStr$(htmlBuffer(),i,250)
      k = k - 250
      i = i + 250
    loop
'    sendText mid(htmlBuffer,i,j-i)+sVarVals(nVarNos(n))
    sendText LGetStr$(htmlBuffer(),i,k)
    sendText sVarVals(nVarNos(n))
? n;" ";nVarNos(n);" ";sVarVals(nVarNos(n))
    n = n + 1
    i = j + 3
    j = nVarNdx(n) 
  loop
'  sendText mid(htmlBuffer,i)
  sendText LGetStr$(htmlBuffer(),i,255)
end sub

sub printHTML
  n = 1
  i = 1
  j = nVarNdx(n) ' location of "~"
  do while j <> 99999
    k = j - i
    do while k > 250
      print SGetStr(htmlBuffer(),i,250)
      k = k - 250
      i = i + 250
    loop
'    sendText mid(htmlBuffer,i,j-i)+sVarVals(nVarNos(n))
    print SGetStr(htmlBuffer(),i,k)
    print sVarVals(nVarNos(n))
    n = n + 1
    i = j + 3
    j = nVarNdx(n) 
  loop
'  sendText mid(htmlBuffer,i)
  print SGetStr(htmlBuffer(),i,255)
end sub

sub rtc_gettime
local integer d(9)
local string dt$,tm$
'  SetPin 14,i2c1sda:  SetPin 15,i2c1scl ' : I2C1 open 100, 1000
I2C1 open 100, 1000
i2c1 WRITE &b1101000,1,1,0 ' set the read address to 0
i2c1 read &h68,0,7,d()
I2C1 close
'option base 0
'dt$=str$(bcd_bin(d(4)))+"-"+str$(bcd_bin(d(5)))+"-20"+str$(bcd_bin(d(6)))
'tm$=str$(bcd_bin(d(2)))+":"+str$(bcd_bin(d(1)))+":"+str$(bcd_bin(d(0)))
'option base 1
dt$=str$(bcd_bin(d(5)))+"-"+str$(bcd_bin(d(6)))+"-20"+str$(bcd_bin(d(7)))
tm$=str$(bcd_bin(d(3)))+":"+str$(bcd_bin(d(2)))+":"+str$(bcd_bin(d(1)))
date$=dt$:time$=tm$
iDayOfWeek=d(4)
end sub

Function bcd_bin (Valu as integer) as integer ' from FruitOfTheShed
  local integer tmp
  ' convert the BCD values to binary
  tmp = valu AND &b00001111
  bcd_bin = (valu AND &b11110000) * 10 / 16 + tmp
END Function
